From c56be5236f29416ecfbd746ee8d25b886e7a8893 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pablo=20Su=C3=A1rez=20Hern=C3=A1ndez?=
 <psuarezhernandez@suse.com>
Date: Wed, 23 Mar 2022 16:16:49 +0000
Subject: [PATCH] Fix multiple security issues (bsc#1197417)

* Sign authentication replies to prevent MiTM (CVE-2020-22935)
* Sign pillar data to prevent MiTM attacks. (CVE-2022-22934)
* Prevent job and fileserver replays (CVE-2022-22936)
* Fixed targeting bug, especially visible when using syndic and user auth. (CVE-2022-22941)
---
 requirements/static/linux.in                |    5 +-
 salt/crypt.py                               |  308 +++---
 salt/master.py                              |   65 +-
 salt/pillar/__init__.py                     |    5 +-
 salt/transport/mixins/auth.py               |  323 +++---
 salt/transport/tcp.py                       |  173 ++-
 salt/transport/zeromq.py                    |  157 ++-
 salt/utils/minions.py                       |   25 +-
 tests/pytests/unit/test_crypt.py            |  149 +++
 tests/pytests/unit/transport/test_zeromq.py | 1042 +++++++++++++++++++
 tests/unit/transport/mixins.py              |   12 +-
 tests/unit/transport/test_tcp.py            |   91 +-
 tests/unit/transport/test_zeromq.py         |  124 ++-
 13 files changed, 2008 insertions(+), 471 deletions(-)
 create mode 100644 tests/pytests/unit/transport/test_zeromq.py

diff --git a/requirements/static/linux.in b/requirements/static/linux.in
index c20b006e2b..bed8943683 100644
--- a/requirements/static/linux.in
+++ b/requirements/static/linux.in
@@ -1,5 +1,6 @@
 apache-libcloud==2.0.0
 boto3
+azure==4.0.0; sys_platform != "win32"
 boto>=2.46.0
 certifi
 cffi
@@ -20,8 +21,8 @@ kubernetes<4.0
 libnacl==1.6.0
 mock>=3.0.5
 more-itertools==5.0.0
-moto
-paramiko>=2.1.6
+moto; python_version >= '3.6'
+paramiko>=2.1.6; python_version >= '3.6'
 psutil
 pygit2
 pyinotify
diff --git a/salt/crypt.py b/salt/crypt.py
index be426c6ab3..d025d807be 100644
--- a/salt/crypt.py
+++ b/salt/crypt.py
@@ -20,6 +20,7 @@ import logging
 import stat
 import traceback
 import binascii
+import uuid
 import weakref
 import getpass
 import salt.ext.tornado.gen
@@ -255,7 +256,11 @@ def verify_signature(pubkey_path, message, signature):
         md = EVP.MessageDigest('sha1')
         md.update(salt.utils.stringutils.to_bytes(message))
         digest = md.final()
-        return pubkey.verify(digest, signature)
+        try:
+            return pubkey.verify(digest, signature)
+        except RSA.RSAError as exc:
+            log.debug("Signature verification failed: %s", exc.args[0])
+            return False
     else:
         verifier = PKCS1_v1_5.new(pubkey)
         return verifier.verify(SHA.new(salt.utils.stringutils.to_bytes(message)), signature)
@@ -655,10 +660,20 @@ class AsyncAuth(object):
                 self._authenticate_future.set_exception(error)
             else:
                 key = self.__key(self.opts)
-                AsyncAuth.creds_map[key] = creds
-                self._creds = creds
-                self._crypticle = Crypticle(self.opts, creds['aes'])
-                self._authenticate_future.set_result(True)  # mark the sign-in as complete
+                if key not in AsyncAuth.creds_map:
+                    log.debug("%s Got new master aes key.", self)
+                    AsyncAuth.creds_map[key] = creds
+                    self._creds = creds
+                    self._crypticle = Crypticle(self.opts, creds["aes"])
+                elif self._creds["aes"] != creds["aes"]:
+                    log.debug("%s The master's aes key has changed.", self)
+                    AsyncAuth.creds_map[key] = creds
+                    self._creds = creds
+                    self._crypticle = Crypticle(self.opts, creds["aes"])
+
+                self._authenticate_future.set_result(
+                    True
+                )  # mark the sign-in as complete
                 # Notify the bus about creds change
                 if self.opts.get('auth_events') is True:
                     with salt.utils.event.get_event(self.opts.get('__role'), opts=self.opts, listen=False) as event:
@@ -681,7 +696,6 @@ class AsyncAuth(object):
         with the publication port and the shared AES key.
 
         '''
-        auth = {}
 
         auth_timeout = self.opts.get('auth_timeout', None)
         if auth_timeout is not None:
@@ -693,10 +707,6 @@ class AsyncAuth(object):
         if auth_tries is not None:
             tries = auth_tries
 
-        m_pub_fn = os.path.join(self.opts['pki_dir'], self.mpub)
-
-        auth['master_uri'] = self.opts['master_uri']
-
         close_channel = False
         if not channel:
             close_channel = True
@@ -722,55 +732,88 @@ class AsyncAuth(object):
         finally:
             if close_channel:
                 channel.close()
+        ret = self.handle_signin_response(sign_in_payload, payload)
+        raise salt.ext.tornado.gen.Return(ret)
 
-        if not isinstance(payload, dict):
-            log.error('Sign-in attempt failed: %s', payload)
-            raise salt.ext.tornado.gen.Return(False)
-        if 'load' in payload:
-            if 'ret' in payload['load']:
-                if not payload['load']['ret']:
-                    if self.opts['rejected_retry']:
-                        log.error(
-                            'The Salt Master has rejected this minion\'s public '
-                            'key.\nTo repair this issue, delete the public key '
-                            'for this minion on the Salt Master.\nThe Salt '
-                            'Minion will attempt to to re-authenicate.'
-                        )
-                        raise salt.ext.tornado.gen.Return('retry')
-                    else:
-                        log.critical(
-                            'The Salt Master has rejected this minion\'s public '
-                            'key!\nTo repair this issue, delete the public key '
-                            'for this minion on the Salt Master and restart this '
-                            'minion.\nOr restart the Salt Master in open mode to '
-                            'clean out the keys. The Salt Minion will now exit.'
-                        )
-                        # Add a random sleep here for systems that are using a
-                        # a service manager to immediately restart the service
-                        # to avoid overloading the system
-                        time.sleep(random.randint(10, 20))
-                        sys.exit(salt.defaults.exitcodes.EX_NOPERM)
-                # has the master returned that its maxed out with minions?
-                elif payload['load']['ret'] == 'full':
-                    raise salt.ext.tornado.gen.Return('full')
-                else:
+    def handle_signin_response(self, sign_in_payload, payload):
+        auth = {}
+        m_pub_fn = os.path.join(self.opts["pki_dir"], self.mpub)
+        auth["master_uri"] = self.opts["master_uri"]
+        if not isinstance(payload, dict) or "load" not in payload:
+            log.error("Sign-in attempt failed: %s", payload)
+            return False
+
+        clear_signed_data = payload["load"]
+        clear_signature = payload["sig"]
+        payload = self.serial.loads(clear_signed_data)
+
+        if "pub_key" in payload:
+            auth["aes"] = self.verify_master(
+                payload, master_pub="token" in sign_in_payload
+            )
+            if not auth["aes"]:
+                log.critical(
+                    "The Salt Master server's public key did not authenticate!\n"
+                    "The master may need to be updated if it is a version of Salt "
+                    "lower than %s, or\n"
+                    "If you are confident that you are connecting to a valid Salt "
+                    "Master, then remove the master public key and restart the "
+                    "Salt Minion.\nThe master public key can be found "
+                    "at:\n%s",
+                    salt.version.__version__,
+                    m_pub_fn,
+                )
+                raise SaltClientError("Invalid master key")
+
+        master_pubkey_path = os.path.join(self.opts["pki_dir"], self.mpub)
+        if os.path.exists(master_pubkey_path) and not verify_signature(
+            master_pubkey_path, clear_signed_data, clear_signature
+        ):
+            log.critical("The payload signature did not validate.")
+            raise SaltClientError("Invalid signature")
+
+        if payload["nonce"] != sign_in_payload["nonce"]:
+            log.critical("The payload nonce did not validate.")
+            raise SaltClientError("Invalid nonce")
+
+        if "ret" in payload:
+            if not payload["ret"]:
+                if self.opts["rejected_retry"]:
                     log.error(
-                        'The Salt Master has cached the public key for this '
-                        'node, this salt minion will wait for %s seconds '
-                        'before attempting to re-authenticate',
-                        self.opts['acceptance_wait_time']
+                        "The Salt Master has rejected this minion's public "
+                        "key.\nTo repair this issue, delete the public key "
+                        "for this minion on the Salt Master.\nThe Salt "
+                        "Minion will attempt to re-authenicate."
                     )
-                    raise salt.ext.tornado.gen.Return('retry')
-        auth['aes'] = self.verify_master(payload, master_pub='token' in sign_in_payload)
-        if not auth['aes']:
-            log.critical(
-                'The Salt Master server\'s public key did not authenticate!\n'
-                'The master may need to be updated if it is a version of Salt '
-                'lower than %s, or\n'
-                'If you are confident that you are connecting to a valid Salt '
-                'Master, then remove the master public key and restart the '
-                'Salt Minion.\nThe master public key can be found '
-                'at:\n%s', salt.version.__version__, m_pub_fn
+                    return "retry"
+                else:
+                    log.critical(
+                        "The Salt Master has rejected this minion's public "
+                        "key!\nTo repair this issue, delete the public key "
+                        "for this minion on the Salt Master and restart this "
+                        "minion.\nOr restart the Salt Master in open mode to "
+                        "clean out the keys. The Salt Minion will now exit."
+                    )
+                    # Add a random sleep here for systems that are using a
+                    # a service manager to immediately restart the service
+                    # to avoid overloading the system
+                    time.sleep(random.randint(10, 20))
+                    sys.exit(salt.defaults.exitcodes.EX_NOPERM)
+            # has the master returned that its maxed out with minions?
+            elif payload["ret"] == "full":
+                return "full"
+            else:
+                log.error(
+                    "The Salt Master has cached the public key for this "
+                    "node, this salt minion will wait for %s seconds "
+                    "before attempting to re-authenticate",
+                    self.opts["acceptance_wait_time"],
+                )
+                return "retry"
+
+        if self.opts.get("syndic_master", False):  # Is syndic
+            syndic_finger = self.opts.get(
+                "syndic_finger", self.opts.get("master_finger", False)
             )
             raise SaltClientError('Invalid master key')
         if self.opts.get('syndic_master', False):  # Is syndic
@@ -779,11 +822,17 @@ class AsyncAuth(object):
                 if salt.utils.crypt.pem_finger(m_pub_fn, sum_type=self.opts['hash_type']) != syndic_finger:
                     self._finger_fail(syndic_finger, m_pub_fn)
         else:
-            if self.opts.get('master_finger', False):
-                if salt.utils.crypt.pem_finger(m_pub_fn, sum_type=self.opts['hash_type']) != self.opts['master_finger']:
-                    self._finger_fail(self.opts['master_finger'], m_pub_fn)
-        auth['publish_port'] = payload['publish_port']
-        raise salt.ext.tornado.gen.Return(auth)
+            if self.opts.get("master_finger", False):
+                if (
+                    salt.utils.crypt.pem_finger(
+                        m_pub_fn, sum_type=self.opts["hash_type"]
+                    )
+                    != self.opts["master_finger"]
+                ):
+                    self._finger_fail(self.opts["master_finger"], m_pub_fn)
+
+        auth["publish_port"] = payload["publish_port"]
+        return auth
 
     def get_keys(self):
         '''
@@ -827,9 +876,10 @@ class AsyncAuth(object):
         :rtype: dict
         '''
         payload = {}
-        payload['cmd'] = '_auth'
-        payload['id'] = self.opts['id']
-        if 'autosign_grains' in self.opts:
+        payload["cmd"] = "_auth"
+        payload["id"] = self.opts["id"]
+        payload["nonce"] = uuid.uuid4().hex
+        if "autosign_grains" in self.opts:
             autosign_grains = {}
             for grain in self.opts['autosign_grains']:
                 autosign_grains[grain] = self.opts['grains'].get(grain, None)
@@ -1191,13 +1241,15 @@ class SAuth(AsyncAuth):
             self.token = Crypticle.generate_key_string()
         else:
             self.token = salt.utils.stringutils.to_bytes(Crypticle.generate_key_string())
+
         self.serial = salt.payload.Serial(self.opts)
-        self.pub_path = os.path.join(self.opts['pki_dir'], 'minion.pub')
-        self.rsa_path = os.path.join(self.opts['pki_dir'], 'minion.pem')
-        if 'syndic_master' in self.opts:
-            self.mpub = 'syndic_master.pub'
-        elif 'alert_master' in self.opts:
-            self.mpub = 'monitor_master.pub'
+        self.pub_path = os.path.join(self.opts["pki_dir"], "minion.pub")
+        self.rsa_path = os.path.join(self.opts["pki_dir"], "minion.pem")
+        self._creds = None
+        if "syndic_master" in self.opts:
+            self.mpub = "syndic_master.pub"
+        elif "alert_master" in self.opts:
+            self.mpub = "monitor_master.pub"
         else:
             self.mpub = 'minion_master.pub'
         if not os.path.isfile(self.pub_path):
@@ -1253,8 +1305,14 @@ class SAuth(AsyncAuth):
                         log.debug('Authentication wait time is %s', acceptance_wait_time)
                     continue
                 break
-            self._creds = creds
-            self._crypticle = Crypticle(self.opts, creds['aes'])
+            if self._creds is None:
+                log.error("%s Got new master aes key.", self)
+                self._creds = creds
+                self._crypticle = Crypticle(self.opts, creds["aes"])
+            elif self._creds["aes"] != creds["aes"]:
+                log.error("%s The master's aes key has changed.", self)
+                self._creds = creds
+                self._crypticle = Crypticle(self.opts, creds["aes"])
 
     def sign_in(self, timeout=60, safe=True, tries=1, channel=None):
         '''
@@ -1309,63 +1367,7 @@ class SAuth(AsyncAuth):
             if close_channel:
                 channel.close()
 
-        if 'load' in payload:
-            if 'ret' in payload['load']:
-                if not payload['load']['ret']:
-                    if self.opts['rejected_retry']:
-                        log.error(
-                            'The Salt Master has rejected this minion\'s public '
-                            'key.\nTo repair this issue, delete the public key '
-                            'for this minion on the Salt Master.\nThe Salt '
-                            'Minion will attempt to to re-authenicate.'
-                        )
-                        return 'retry'
-                    else:
-                        log.critical(
-                            'The Salt Master has rejected this minion\'s public '
-                            'key!\nTo repair this issue, delete the public key '
-                            'for this minion on the Salt Master and restart this '
-                            'minion.\nOr restart the Salt Master in open mode to '
-                            'clean out the keys. The Salt Minion will now exit.'
-                        )
-                        sys.exit(salt.defaults.exitcodes.EX_NOPERM)
-                # has the master returned that its maxed out with minions?
-                elif payload['load']['ret'] == 'full':
-                    return 'full'
-                else:
-                    log.error(
-                        'The Salt Master has cached the public key for this '
-                        'node. If this is the first time connecting to this '
-                        'master then this key may need to be accepted using '
-                        '\'salt-key -a %s\' on the salt master. This salt '
-                        'minion will wait for %s seconds before attempting '
-                        'to re-authenticate.',
-                        self.opts['id'], self.opts['acceptance_wait_time']
-                    )
-                    return 'retry'
-        auth['aes'] = self.verify_master(payload, master_pub='token' in sign_in_payload)
-        if not auth['aes']:
-            log.critical(
-                'The Salt Master server\'s public key did not authenticate!\n'
-                'The master may need to be updated if it is a version of Salt '
-                'lower than %s, or\n'
-                'If you are confident that you are connecting to a valid Salt '
-                'Master, then remove the master public key and restart the '
-                'Salt Minion.\nThe master public key can be found '
-                'at:\n%s', salt.version.__version__, m_pub_fn
-            )
-            sys.exit(42)
-        if self.opts.get('syndic_master', False):  # Is syndic
-            syndic_finger = self.opts.get('syndic_finger', self.opts.get('master_finger', False))
-            if syndic_finger:
-                if salt.utils.crypt.pem_finger(m_pub_fn, sum_type=self.opts['hash_type']) != syndic_finger:
-                    self._finger_fail(syndic_finger, m_pub_fn)
-        else:
-            if self.opts.get('master_finger', False):
-                if salt.utils.crypt.pem_finger(m_pub_fn, sum_type=self.opts['hash_type']) != self.opts['master_finger']:
-                    self._finger_fail(self.opts['master_finger'], m_pub_fn)
-        auth['publish_port'] = payload['publish_port']
-        return auth
+        return self.handle_signin_response(sign_in_payload, payload)
 
 
 class Crypticle(object):
@@ -1380,11 +1382,11 @@ class Crypticle(object):
     AES_BLOCK_SIZE = 16
     SIG_SIZE = hashlib.sha256().digest_size
 
-    def __init__(self, opts, key_string, key_size=192):
+    def __init__(self, opts, key_string, key_size=192, serial=0):
         self.key_string = key_string
         self.keys = self.extract_keys(self.key_string, key_size)
         self.key_size = key_size
-        self.serial = salt.payload.Serial(opts)
+        self.serial = serial
 
     @classmethod
     def generate_key_string(cls, key_size=192):
@@ -1464,19 +1466,45 @@ class Crypticle(object):
         else:
             return data[:-data[-1]]
 
-    def dumps(self, obj):
-        '''
+    def dumps(self, obj, nonce=None):
+        """
         Serialize and encrypt a python object
-        '''
-        return self.encrypt(self.PICKLE_PAD + self.serial.dumps(obj))
+        """
+        if nonce:
+            toencrypt = (
+                self.PICKLE_PAD + nonce.encode() + salt.payload.Serial({}).dumps(obj)
+            )
+        else:
+            toencrypt = self.PICKLE_PAD + salt.payload.Serial({}).dumps(obj)
+        return self.encrypt(toencrypt)
 
-    def loads(self, data, raw=False):
-        '''
+    def loads(self, data, raw=False, nonce=None):
+        """
         Decrypt and un-serialize a python object
-        '''
+        """
         data = self.decrypt(data)
         # simple integrity check to verify that we got meaningful data
         if not data.startswith(self.PICKLE_PAD):
             return {}
-        load = self.serial.loads(data[len(self.PICKLE_PAD):], raw=raw)
-        return load
+        data = data[len(self.PICKLE_PAD) :]
+        if nonce:
+            ret_nonce = data[:32].decode()
+            data = data[32:]
+            if ret_nonce != nonce:
+                raise SaltClientError("Nonce verification error")
+        payload = salt.payload.Serial({}).loads(data, raw=raw)
+        if isinstance(payload, dict):
+            if "serial" in payload:
+                serial = payload.pop("serial")
+                if serial <= self.serial:
+                    log.critical(
+                        "A message with an invalid serial was received.\n"
+                        "this serial: %d\n"
+                        "last serial: %d\n"
+                        "The minion will not honor this request.",
+                        serial,
+                        self.serial,
+                    )
+                    return {}
+                self.serial = serial
+        return payload
diff --git a/salt/master.py b/salt/master.py
index 8bccc00036..dda920b511 100644
--- a/salt/master.py
+++ b/salt/master.py
@@ -138,6 +138,51 @@ class SMaster(object):
         '''
         return salt.daemons.masterapi.access_keys(self.opts)
 
+    @classmethod
+    def get_serial(cls, opts=None, event=None, lock=True):
+        if lock:
+            with cls.secrets["aes"]["secret"].get_lock():
+                if cls.secrets["aes"]["serial"].value == sys.maxsize:
+                    cls.rotate_secrets(opts, event, use_lock=False)
+                else:
+                    cls.secrets["aes"]["serial"].value += 1
+                return cls.secrets["aes"]["serial"].value
+        else:
+            if cls.secrets["aes"]["serial"].value == sys.maxsize:
+                cls.rotate_secrets(opts, event, use_lock=False)
+            else:
+                cls.secrets["aes"]["serial"].value += 1
+            return cls.secrets["aes"]["serial"].value
+
+    @classmethod
+    def rotate_secrets(cls, opts=None, event=None, use_lock=True):
+        log.info("Rotating master AES key")
+        if opts is None:
+            opts = {}
+
+        for secret_key, secret_map in cls.secrets.items():
+            # should be unnecessary-- since no one else should be modifying
+            if use_lock:
+                with secret_map["secret"].get_lock():
+                    secret_map["secret"].value = salt.utils.stringutils.to_bytes(
+                        secret_map["reload"]()
+                    )
+                    if "serial" in secret_map:
+                        secret_map["serial"].value = 0
+            else:
+                secret_map["secret"].value = salt.utils.stringutils.to_bytes(
+                    secret_map["reload"]()
+                )
+                if "serial" in secret_map:
+                    secret_map["serial"].value = 0
+            if event:
+                event.fire_event({"rotate_{}_key".format(secret_key): True}, tag="key")
+
+        if opts.get("ping_on_rotate"):
+            # Ping all minions to get them to pick up the new key
+            log.debug("Pinging all connected minions due to key rotation")
+            salt.utils.master.ping_all_connected_minions(opts)
+
 
 class Maintenance(salt.utils.process.SignalHandlingProcess):
     '''
@@ -298,18 +343,8 @@ class Maintenance(salt.utils.process.SignalHandlingProcess):
                 to_rotate = True
 
         if to_rotate:
-            log.info('Rotating master AES key')
-            for secret_key, secret_map in six.iteritems(SMaster.secrets):
-                # should be unnecessary-- since no one else should be modifying
-                with secret_map['secret'].get_lock():
-                    secret_map['secret'].value = salt.utils.stringutils.to_bytes(secret_map['reload']())
-                self.event.fire_event({'rotate_{0}_key'.format(secret_key): True}, tag='key')
+            SMaster.rotate_secrets(self.opts, self.event)
             self.rotate = now
-            if self.opts.get('ping_on_rotate'):
-                # Ping all minions to get them to pick up the new key
-                log.debug('Pinging all connected minions '
-                          'due to key rotation')
-                salt.utils.master.ping_all_connected_minions(self.opts)
 
     def handle_git_pillar(self):
         '''
@@ -671,9 +706,13 @@ class Master(SMaster):
                         salt.crypt.Crypticle.generate_key_string()
                     )
                 ),
-                'reload': salt.crypt.Crypticle.generate_key_string
+                "serial": multiprocessing.Value(
+                    ctypes.c_longlong, lock=False  # We'll use the lock from 'secret'
+                ),
+                "reload": salt.crypt.Crypticle.generate_key_string,
             }
-            log.info('Creating master process manager')
+
+            log.info("Creating master process manager")
             # Since there are children having their own ProcessManager we should wait for kill more time.
             self.process_manager = salt.utils.process.ProcessManager(wait_for_kill=5)
             pub_channels = []
diff --git a/salt/pillar/__init__.py b/salt/pillar/__init__.py
index 6b36cda708..81a0417d0f 100644
--- a/salt/pillar/__init__.py
+++ b/salt/pillar/__init__.py
@@ -13,7 +13,7 @@ import logging
 import salt.ext.tornado.gen
 import sys
 import traceback
-import inspect
+import uuid
 
 # Import salt libs
 import salt.loader
@@ -178,6 +178,9 @@ class AsyncRemotePillar(RemotePillarMixin):
                 load,
                 dictkey='pillar',
             )
+        except salt.crypt.AuthenticationError as exc:
+            log.error(exc.message)
+            raise SaltClientError("Exception getting pillar.")
         except Exception:  # pylint: disable=broad-except
             log.exception('Exception getting pillar:')
             raise SaltClientError('Exception getting pillar.')
